//工具类，与业务逻辑无关。
var st = {
    bytesize: function (num, unit) {						//获取指定单位所对应的byte大小
        var y = { 'k': 1, 'kb': 1, 'm': 2, 'mb': 2, 'g': 3, 'gb': 3, 't': 4, 'tb': 4 }[unit ? unit.toLowerCase() : ''];
        return num * Math.pow(1024, y ? y : 0);
    },
	sizeformat:function(bytesize){							//将byte大小转换成保留两位小数的尺寸
		var size=bytesize*1.0
		var flag=1024*1024*1024*1024
		var rt=0.0
		var unit=""
		if(size>=flag){
			rt=size/flag
			unit="TB"
		}else if(size>=flag/1024){
			rt=size/(flag/1024)
			unit="GB"
		}else if(size>=flag/1024/1024){
			rt=size/(flag/1024/1024)
			unit="MB"
		}else if(size>=flag/1024/1024/1024){
			rt=size/(flag/1024/1024/1024)
			unit="KB"
		}else{
			rt = size
			unit="B"
		}
		return (Math.floor(rt*100)/100).toString().trimEnd('0').trimEnd('.')+''+unit
	},
    todate: function (str) {				//将字符型的日期转换成日期，兼容ios格式
        return new Date(str.replace(/-/g, '/'));
    },
	int: function (num) {												/*转换成数字*/
        return /^[1-9]+[0-9]*]*$/.test(num) ? num * 1 : 0;
    },
	randcolor:function(){					//随机生成颜色
		var r=Math.floor(100+Math.random()*156);
		var g=Math.floor(100+Math.random()*156);
		var b=Math.floor(Math.random()*156);
		return "rgb("+r+','+g+','+b+")";//所有方法的拼接都可以用ES6新特性`其他字符串{$变量名}`替换
	},
	isjson:function(str){				//判断一个字符串是否是有效的json格式
		try{JSON.parse(str);return true}catch(e){return false}
	},
	getstore: function(key, djson) {
        //从本地存储中获取json对象。如果不存在用默认值替代       
        try {
            var storestr = localStorage.getItem(key);
            return st.tojson(storestr, djson ? djson : {});

        } catch (e) {
        }
    },
	extend:function(filename){		//获取文件扩展名
		if(!filename){return ''}
		if(filename.indexOf('.')<0){return ''}
		var pars=filename.split('.')
		return pars[pars.length-1]
	},
    setstore: function(key, json) {
        //将json对象存储到本地存储中。
        try {
            localStorage.setItem(key, JSON.stringify(json));
        } catch (e) {
        }
    },
	bindinputedit:function(input,endcallback){	//绑定input的操作事件。
        input.keyup(function(e){if(e.key=='Enter'){endcallback(input)}});
	},
	mstotime:function(ms){			//将毫秒转为分秒格式。
		return st.format(new Date().setTime(ms),'mm:ss.SSS');	
	},
	randcolorlist:function(len){		//随机产生一组颜色
		var colors=[];
		for(var i=0;i<len;i++){colors[colors.length]=this.randcolor();}
		return colors;
	},
	cutstr:function(str,len){
		if(!str){return '';}
		return str.length>len?str.substr(0,len)+'...':str;
	},
    disabled: function (obj, isdisabled) {
        if (isdisabled) { obj.attr('disabled', 'disabled') } else { obj.removeAttr('disabled') }
    },
    switchshow: function (obj1, obj2, showfirst) {	//根据判定条件，隐藏一部分显示一部分
        if (showfirst) { obj1.show(); obj2.hide(); } else { obj2.show(); obj1.hide(); }
    },
    in: function (array, data) {								/*判断某个元素是否存在集合中*/
        for (var o in array) { if (data == array[o]) { return true; } }
        return false;
    },
	jksort:function(json){							/*对json进行键排序*/
		var ks=[],j={}
		for(var o in json){ks[ks.length]=o}
		ks.sort();
		for(var o in ks){j[ks[o]]=json[ks[o]]}
		return j;
	},
    jsort: function (list, key, isdesc) {								/*按照指定字段进行排序*/
        return list.sort(function (a, b) { return ((a[key] * 1) < (b[key] * 1) ? -1 : 1) * (isdesc ? -1 : 1) });
    },
    jsondel: function (array, col) {
        for (var o in array) { array[o][col] = null }
        return array;
    },
    isdatetime: function (str) {		//判断一个str是否是时间日期格式的。
        var a = /^(?:19|20)[0-9][0-9]-(?:(?:0[1-9])|(?:1[0-2]))-(?:(?:[0-2][1-9])|(?:[1-3][0-1])) (?:(?:[0-2][0-3])|(?:[0-1][0-9])):[0-5][0-9]:[0-5][0-9]$/;
        return a.test(str);
    },
	isdate: function (str) {			//判断一个str是否是日期格式的 如:2018-11-11。
        var a = /^(?:19|20)[0-9][0-9]-(?:(?:0[1-9])|(?:1[0-2]))-(?:(?:[0-2][1-9])|(?:[1-3][0-1]))$/;
        return a.test(str);
    },
	istime: function (str) {			//判断一个str是否是时间格式的 如:12:22:33。
        var a = /^(?:(?:[0-2][0-3])|(?:[0-1][0-9])):[0-5][0-9]:[0-5][0-9]$/;
        return a.test(str);
    },
    jsonsum: function (array, col) {
        var c = 0;
        for (var o in array) { var dr = array[o]; c += col ? dr[col] : dr; }
        return c;
    },
    jsonin: function (array, data, col) {								/*判断某个json元素是否存在集合中,判断依据指定字段与目标值是否匹配*/
        for (var o in array) { if (array[o] && data == array[o][col]) { return true; } }
        return false;
    },
    float2: function (strnum) {                                      //将字符型的小数保留两位
        try {
            return (strnum ? strnum * 1 : 0).toFixed(2)
        } catch (e) {
            return 0;
        }
    },
    clicksel: function (obj) {									//绑定点击全选
        obj.click(function () { $(this).select(); });
    },
    jsonfind: function (array,col,val) {						/*判断某个json元素是否存在集合中,判断依据指定字段与目标值是否匹配,多路径用.分割*/
        for (var o in array) { 
			if (array[o] && val == array[o][col]) { return array[o]; } 
		}
        return {};
    },
    jsonfindlist: function (array,col,val) {						/*判断某个json元素是否存在集合中,判断依据指定字段与目标值是否匹配*/
        var rlist=[];
        for (var o in array) { if (array[o] && val == array[o][col]) {
			rlist[rlist.length]= array[o];
           }
        }
        return rlist;
    },
    arrayremove: function (list, i) {							/*删除指定位置的元素*/
        var rlist = [];
        for (var o in list) { if (o != i) { rlist[rlist.length] = list[o] } }
        return rlist;
    },

    slist: function (array, key, val) {									/*查找集合中指定键值所对应的集合*/
        for (var o in array) { if (val == array[o][key]) { return array[o] } }
        return {};
    },
    isempty: function (str) {										/*判断字符串对象是否为空*/
        return str == null || str == undefined || str == "";
    },
    visible: function (obj, isshow) {								/*控制jquery对象的显示和隐藏。不改变大小*/
        obj.css("visibility", isshow ? "visible" : "hidden");
    },
    display: function (obj, isshow) {					/*控制jquery对象的显示和隐藏。改变大小*/
        isshow ? obj.show() : obj.hide();
    },
    todayadd: function (days) {                                    //返回今天所添加指定天数后的日期
        return new Date(new Date().valueOf() + 1000 * 3600 * 24 * days);
    },
    timeadd: function (days) {                                    //返回今天所添加指定天数后的日期 yyyyMMdd格式
        return st.format(new Date(new Date().valueOf() + 1000 * 3600 * 24 * days),'yyyyMMdd').toString();
    },
    nowdate: function () {												//返回当前时间的日期形式
        return st.format(new Date(), 'yyyy-MM-dd');
    },
    now: function () {													//返回当前时间的字符串形式
        return st.format(new Date(), 'yyyy-MM-dd HH:mm:ss');
    },
    tweek: function () {                                              //当前周的日期
        return this.todayadd(-(new Date().getDay()) + 1)
    },

    tmonth: function () {                                             //本月1号
        return new Date(st.format(new Date(), 'yyyy-MM-1'))
    },
    lmonth: function () {                                              //上月1号
        var x = new Date(); x.setMonth(x.getMonth() - 1)
        return new Date(st.format(x, 'yyyy-MM-1'))
    },
	month:function(monthadd){						//获取月份字符串
        var x = new Date(); x.setMonth(x.getMonth() - (monthadd?monthadd:0))
        return st.format(x, 'yyyy年MM月');
	},
    dayadd: function (date, days) {		            //添加整天数。日期参数为字符型
		return this.secondadd(date,days*24*3600);
    },
	secondadd:function(date,seconds){				//对指定日期添加指定秒数
        return new Date(new Date(date).valueOf() + 1000 * seconds);
	},
	isenname:function(str){							//判断字符串是否是英文名称。英文关键字约束。
        return /^[a-zA-Z0-9_]+$/g.test(str);
	},
    getdatestr: function (labeldate,format) {                                //获取日期字符串
        if (labeldate == st.format(new Date(), 'yyyyMMdd')) { return '今日' }
        if (labeldate == st.format(st.todayadd(-1), 'yyyyMMdd')) { return '昨日' }
        return labeldate.replace(/(\d{4})(\d{2})(\d{2})/mg, format?format:'$1-$2-$3');
    },
    //获取上周的开始日期
    getUpWeekStartDate:function(){
        var now = new Date(); //当前日期
        var nowDayOfWeek = now.getDay(); //今天本周的第几天
        var nowDay = now.getDate(); //当前日
        var nowMonth = now.getMonth(); //当前月
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0;
        var getUpWeekStartDate = new Date(nowYear, nowMonth, nowDay - nowDayOfWeek -7 + 1);
        return  st.formatDate(getUpWeekStartDate);
    },
    //获取上周的结束日期
    getUpWeekEndDate:function () {
        var now = new Date(); //当前日期
        var nowDayOfWeek = now.getDay(); //今天本周的第几天
        var nowDay = now.getDate(); //当前日
        var nowMonth = now.getMonth(); //当前月
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0;
        var getUpWeekEndDate = new Date(nowYear, nowMonth, nowDay + (7 - nowDayOfWeek - 7));
        return st.formatDate(getUpWeekEndDate);
    },
    //获得本周的开始日期
    getWeekStartDate:function() {
        var now = new Date(); //当前日期
        var nowDayOfWeek = now.getDay(); //今天本周的第几天
        var nowDay = now.getDate(); //当前日
        var nowMonth = now.getMonth(); //当前月
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0;
        var weekStartDate = new Date(nowYear, nowMonth, nowDay - nowDayOfWeek + 1);
        return st.formatDate(weekStartDate);
    },
    //格式化日期：yyyy-MM-dd
    formatDate:function (date) {
    var myyear = date.getFullYear();
    var mymonth = date.getMonth()+1;
    var myweekday = date.getDate();
        if(mymonth < 10){
            mymonth = "0" + mymonth;
        }
        if(myweekday < 10){
            myweekday = "0" + myweekday;
        }
        return (myyear+"-"+mymonth + "-" + myweekday);
    },
    //获得本周的结束日期
    getWeekEndDate:function() {
        var now = new Date(); //当前日期
        var nowDayOfWeek = now.getDay(); //今天本周的第几天
        var nowDay = now.getDate(); //当前日
        var nowMonth = now.getMonth(); //当前月
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0; //
    var weekEndDate = new Date(nowYear, nowMonth, nowDay + (7 - nowDayOfWeek));
    return st.formatDate(weekEndDate);
    },

    //获得本月的开始日期
    getMonthStartDate:function(){
        var now = new Date(); //当前日期
        var nowMonth = now.getMonth(); //当前月
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0; //
    var monthStartDate = new Date(nowYear, nowMonth, 1);
    return st.formatDate(monthStartDate);
    },

    //获得本月的结束日期
    getMonthEndDate:function(){
        var now = new Date(); //当前日期
        var nowMonth = now.getMonth(); //当前月
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0; //
    var monthEndDate = new Date(nowYear, nowMonth, st.getMonthDays(nowMonth));
    return st.formatDate(monthEndDate);
    },
    //获得某月的天数
    getMonthDays:function(myMonth){
        var now = new Date(); //当前日期
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0; //
    var monthStartDate = new Date(nowYear, myMonth, 1);
    var monthEndDate = new Date(nowYear, myMonth + 1, 1);
    var days = (monthEndDate - monthStartDate)/(1000 * 60 * 60 * 24);
    return days;
    },
    //获得上月开始时间
    getLastMonthStartDate:function(){
        var now = new Date(); //当前日期
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0; //
        var lastMonthDate = new Date(); //上月日期
        lastMonthDate.setDate(1);
        lastMonthDate.setMonth(lastMonthDate.getMonth()-1);
        var lastMonth = lastMonthDate.getMonth();
    var lastMonthStartDate = new Date(nowYear, lastMonth, 1);
    return st.formatDate(lastMonthStartDate);
    },

    //获得上月结束时间
    getLastMonthEndDate:function(){
        var now = new Date(); //当前日期
        var nowYear = now.getYear(); //当前年
        nowYear += (nowYear < 2000) ? 1900 : 0; //
        var lastMonthDate = new Date(); //上月日期
        lastMonthDate.setDate(1);
        lastMonthDate.setMonth(lastMonthDate.getMonth()-1);
        var lastMonth = lastMonthDate.getMonth();
    var lastMonthEndDate = new Date(nowYear, lastMonth, st.getMonthDays(lastMonth));
    return st.formatDate(lastMonthEndDate);
    },
    getdatediff: function (startTime, endTime, diffType) {
        //将xxxx-xx-xx的时间格式，转换为 xxxx/xx/xx的格式 
        startTime = startTime.replace(/\-/g, "/");
        endTime = endTime.replace(/\-/g, "/");

        //将计算间隔类性字符转换为小写
        diffType = diffType.toLowerCase();
        var sTime = new Date(startTime);      //开始时间
        var eTime = new Date(endTime);  //结束时间
        //作为除数的数字
        var divNum = 1;
        switch (diffType) {
            case "second":
                divNum = 1000;
                break;
            case "minute":
                divNum = 1000 * 60;
                break;
            case "hour":
                divNum = 1000 * 3600;
                break;
            case "day":
                divNum = 1000 * 3600 * 24;
                break;
            default:
                break;
        }
        return parseInt((eTime.getTime() - sTime.getTime()) / parseInt(divNum));
    },
	gologin:function(){				//跳转到登录页
		window.location.href=loginpage+'?backurl='+encodeURIComponent(window.location.href);
	},
	sf:function(str,...args){		//格式化字符串拼接
		if(args.length==0){return str}
		for (var o in args) {str = str.replace(new RegExp("\\{" + o + "\\}", "g"), args[o]); }
		return str;
	},
    format: function (time, format='yyyy-MM-dd HH:mm:ss') {	/*格式化日期,默认标准*/
        var t = new Date(typeof (time) == 'string' ? time.replace(/-/g, '/') : time);
        var tf = function (i, f) { return (i < 10 ? (f.length == 1 ? '' : '0') : '') + i };
        return format.replace(/yyyy|MM|M|dd|d|HH|H|mm|m|ss|s|SSS/g, function (a) {
            switch (a) {
                case 'yyyy':
                    return tf(t.getFullYear(), a);
                case 'MM':
                    return tf(t.getMonth() + 1, a);
                case 'M':
                    return tf(t.getMonth() + 1, a);
                case 'mm':
                    return tf(t.getMinutes(), a);
                case 'm':
                    return tf(t.getMinutes(), a);
                case 'dd':
                    return tf(t.getDate(), a);
                case 'd':
                    return tf(t.getDate(), a);
                case 'HH':
                    return tf(t.getHours(), a);
                case 'H':
                    return tf(t.getHours(), a);
                case 'ss':
                    return tf(t.getSeconds(), a);
                case 's':
                    return tf(t.getSeconds(), a);
                case 'SSS':
                    return tf(t.getMilliseconds(), a);
            }
        })
    },
    isemail: function (email) {                                                                                                       //判断字符串是否是邮箱
        return RegExp(/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/).test(email);
    },
    join: function (list, key, c) {									//对列表的指定属性转换成","分隔的形式
        if (list == null || list.length == 0) { return "" }
        var str = "";
        for (var o in list) { str += list[o][key] + (c ? c : ',') }
        return str.substr(0, str.length - 1);
    },
    getquerystring: function(name)   //获取地址栏参数
    {
        var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if(r!=null)return  unescape(r[2]); return null;
    },
    tothousands: function (num) {
        var l = (num || 0).toString().split('.');
        return l[0].replace(/(\d)(?=(?:\d{3})+$)/g, '$1,') + (l[1] ? '.' + l[1] : '');
    },
    space: function (str, maxlen) {								/*对字符串进行前端空格补齐*/
        var space = ""; for (var i = 0; i < maxlen - str.length * 2; i++) { space += "&nbsp;&nbsp;" } return space + str;
    },
    spacer: function (number, maxlen) {							/*用空格填充数字后端空白。到指定长度*/
        var space = number + ""; for (var i = space.length; i < maxlen; i++) { space += "&nbsp;&nbsp;" } return space;
    },
    //判断一个对象是否是函数对象。
    isfunction: function (obj) {
        return typeof (obj) == "function";
    },
    f: function (list, func) {									//遍历
        for (var o in list) {
            if (func) { if (func(list[o], o) == false) { return } }
        }
    },
	ischeck:function(obj){										//判断checkbox是否被选中
		if(obj.size()==0){return false;}
		return obj.get(0).checked==true?1:0;
	},
    radioval: function (name, content) {
        str = '[name=' + name + ']:checked';
        return (content ? content.find(str) : $(str)).val();
    },
    inputlencheck: function (input, maxlen, callback) {									/*字符输入长度检查,回调剩余文字*/
        var me = this;
        input.keyup(function () {
            var left = st.round((maxlen * 2 - me.strlen(input.val())) / 2);
            if (callback) { callback(left < 0 ? 0 : left) }
        });
    },
    inputnumber: function (input) {	/*设置input元素只能输入数字.input:input的jquery对象。如:$("#id")*/
        input.keyup(function () {
            this.value = this.value.replace(/[^\d]/g, '').replace(/(\d{4})(?=\d)/g, "$1 ");//如果输入非数字，则替换为''，如果输入数字，则在每4位之后添加一个空格分隔
        });
    },
    number: function (input) {							/*设置input元素只能输入数字.input:input的jquery对象。如:$("#id")*/
        input.keyup(function () {
            this.value = this.value.replace(/[^\d]/g, '');//如果输入非数字，则替换为''
        });
    },
    isurl: function (str_url) {
		var re=/(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/;
        return re.test(str_url);
    },
    bool: function (boolenstring) {							/*将字符形式的布尔值转换成布尔型*/
        if (boolenstring == null) { return false; }
        return boolenstring.toLowerCase() == "true";
    },
    nullstr: function (str) {
        return str == null ? '' : str;
    },
    addlink: function (url) {
        if ($("[href='" + url + "']").length != 0) { return; }
        var hint = document.createElement("link")
        hint.setAttribute("rel", "prerender")
        hint.setAttribute("href", url)
        document.getElementsByTagName("head")[0].appendChild(hint)
    },
    preresources: function (json) {
        for (var o in json.figurelist) { this.addlink(json.figurelist[o].ImageUrl); }
        for (var o in json.scenelist) { this.addlink(json.scenelist[o].FgUrl); this.addlink(json.scenelist[o].BgUrl); }
    },
    temp: function (query, parent) {							/*通过query查询条件所获取其复制并显示。主要用于前端模板*/
        if (parent != null) { return parent.find(query).clone().show() }
        return $(query).clone().show();
    },
    reflashOpener: function () {								/*刷新父窗口*/
        if (window.opener == null) { return; }
        window.opener.location.href = window.opener.location.href;
    },
    undrag: function (objs) {							/*使指定对象屏蔽拖动*/
        for (var i in objs) { if (objs[i] == null) { continue }; objs[i].get(0).ontouchmove = function (e) { e.preventDefault() } }	//屏蔽滚动
    },
    tojson: function (str, def) {
        if (this.isempty(str)) { return def }
        try
        { return eval("(" + str + ")") }
        catch (e) {
            return def;
        };
    },
    rint: function (num) {                                         /*获取指定int范围内的随机int数。范围0~n*/
        return Math.floor(Math.random() * num);
    },
    rstr:function(str,len){		//随机产生字符串。备选字符字符串形式。如：123456789
        var rstr=[],chars=str.split('');
        for(var i=0;i<len;i++){rstr[rstr.length]=chars[this.rint(chars.length)]}
        return rstr.join('');
    },
    wordrstr:function(len){		//随机产生len长度的字母字符串。
        var str="abcdefghijklmnopqrstuvwxyz";
        var rstr=[],chars=str.split('');
        for(var i=0;i<len;i++){rstr[rstr.length]=chars[this.rint(chars.length)]}
        return rstr.join('');
    },
    refalsh: function () {												/*重新刷新页面*/
        window.location.href = window.location.href;
    },
    cachedata: {},
    setcache: function (key, value) {									/*数据缓存方法,缓存数据*/
        this.cachedata[key] = value;
    },
    getcache: function (key) {
        return this.cachedata[key];
    },
    candrag: function (objs) {
        for (var i in objs) { objs[i].get(0).ontouchmove = null }	//取消屏蔽滚动
    },
    alert: function (json) {
        alert(JSON.stringify(json));
    },
    int: function (num, def) {												/*转换成数字*/
        return /^[1-9]+[0-9]*]*$/.test(num) ? num * 1 : (def ? def : 0);
    },
    last: function (list) {											/*获取集合中最后一条记录*/
        return list == null || list.length == 0 ? {} : list[list.length - 1];
    },
    isjsonempty: function (json) {
        return json == null || JSON.stringify(json) == "{}" || JSON.stringify(json) == "[]";
    },
    tounicode: function (str) {										/*unicode编码*/
        var res = []; str = str.replace('\n', '').replace('\r', '').replace('\t', '');
        for (var i = 0; i < str.length; i++) { res[i] = ("00" + str.charCodeAt(i).toString(16)).slice(-4) };
        return res.length == 0 ? "" : "\\u" + res.join("\\u");
    },
    fromunicode: function (str) {										/*unicode解码*/
        if (st.isempty(str)) { return "" }
        return unescape(str.replace(/\\/g, "%"));
    },
    class: function (obj, name) {											/*移除类名，并设置新的类名*/
        return obj.removeClass().addClass(name);
    },
	singlesel:function(obj,name){						/**设置样式,去掉兄弟样式**/
		obj.parent().children().removeClass();
        return obj.removeClass().addClass(name);
	},
    mtoh: function (minutes) {                                             //将分钟数化成小时分钟数
        var h = (minutes - minutes % 60) / 60;
        var m = (minutes % 60);
        return (h > 9 ? '' : '0') + h + '小时' + (m > 9 ? '' : '0') + m + '分';
    },
    numberinput: function (input, changecb) {										/*限制input只能输入数字*/
        input.keyup(function () {
            if ($(this).val().length > 0 && !/^\d+$/g.test($(this).val())) {
                $(this).val($(this).attr('last'));
            }
            $(this).attr('last', $(this).val());
            if (changecb) { changecb(input) }
        });
        input.attr('last', input.val());
        if (changecb) { changecb(input) }
    },

    getpyoption: function (isshow, json) {     //对下拉列表进行排序显示
        var namelist = json.sort(function (a, b) { return a.namepy > b.namepy ? 1 : -1 })
        var optionstring = "";
        var a = 1;
        for (var i in namelist) {
            var jsonObj = json[i];
            if (!st.isempty(isshow))
            { if (jsonObj.isshow == "False" || jsonObj.isshow == 0) { continue; } }
            if (jsonObj.namepy != a) {
                optionstring += "<option disabled='disabled' value='-1'>" + jsonObj.namepy + "</option><option zm=\"" + jsonObj.namepy + "\" value=\"" + jsonObj.id + "\" >" + jsonObj.name + "</option>";
                a = jsonObj.namepy
            } else {
                optionstring += "<option zm=\"" + jsonObj.namepy + "\" value=\"" + jsonObj.id + "\" >" + jsonObj.name + "</option>";
            }
        }
        return optionstring;
    },
    phoneinput: function (input, callback, error, formaterror, empty) {														/*限制input只能输入手机*/
        var ninput = input.get(0); ninput.callback = callback; ninput.error = error; ninput.formaterror = formaterror; ninput.isempty = empty
        ninput.oninput = function () {
            if (this.value.length == 0) { if (this.isempty) { this.isempty(); return; } }
            if (!this.valueAsNumber || this.value.length > 11) { var last = $(this).attr('last'); if (last && !st.isempty($(this).val())) { this.value = last; } else { this.value = ''; } return; }							//无效数据回滚
            $(this).attr('last', this.value);															//保留备份
            if (this.value.length < 11) { if (this.formaterror) { this.formaterror(); } return; }															//字符长度判断
            if (/^1\d{10}$/g.test(this.value)) { if (this.callback) { this.callback() } } else { if (this.error) { this.error() } }		//长度达到手机号长度。进行有效性判断。
        };
        input.attr('last', this.value);//设置默认值
    },
    jsontopara: function (data) {                                                  //将json数据转换成url参数
        var param = '';
        for (var o in data) {
            param += '&' + o + '=' + (st.in(['subject', 'description'], o) ? encodeURIComponent(data[o]) : data[o]);
        }
        return param.substr(1);
    },
    codeinput: function (input) {														/*限制input只能输入验证码*/
        input.get(0).oninput = function () {
            if (!this.valueAsNumber || this.value.length > 6) { var last = $(this).attr('last'); if (last && !st.isempty($(this).val())) { this.value = last; } else { this.value = ''; } return; }							//无效数据回滚
            $(this).attr('last', this.value);															//保留备份
        };
        input.attr('last', this.value);//设置默认值
    },
    pwdinput: function (input, error, ok, empty) {
        var ninput = input.get(0); ninput.error = error; ninput.ok = ok; ninput.isempty = empty
        ninput.oninput = function () {
            if (this.value.length == 0) { if (this.isempty) { this.isempty(); return; } }
            if (escape(this.value).indexOf("%u") > 0 || / /g.test(this.value)) { if (this.error) { this.error() } return; }
            $(this).attr('last', this.value); if (this.ok) { this.ok() }
        };
        input.attr('last', this.value);//设置默认值
    },
    rgbinput: function (input, callback) {										/*限制input只能输入数字*/
        input.keyup(function () {
            if ($(this).val().length > 0 && !/^[\da-fA-F]+$/g.test($(this).val())) {
                $(this).val($(this).attr('last'));
            }
            $(this).attr('last', $(this).val());
            if (callback) { callback($(this).val()); }
        });
        input.attr('last', input.val())
        if (callback) { callback(input.val()); }
    },
    versions: function () {
        var u = navigator.userAgent, app = navigator.appVersion;
        return {//移动终端浏览器版本信息
            trident: u.indexOf('Trident') > -1, //IE内核
            presto: u.indexOf('Presto') > -1, //opera内核
            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
            mobile: !!u.match(/AppleWebKit.*Mobile.*/) || !!u.match(/AppleWebKit/), //是否为移动终端
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或者uc浏览器
            iPhone: u.indexOf('iPhone') > -1 || u.indexOf('Mac') > -1, //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
            liebao: u.indexOf('LieBaoFast') > -1,	//是否是猎豹浏览器
            b360: u.indexOf('360 Aphone') > -1,	//是否是360
            sogou: u.indexOf('SogouMobileBrowser') > -1	//是否是搜狗
        };
    }(),
    formatwan: function (num) {
        if (num > 10000) { return (num - num % 10000) / 10000 + '万' + (num % 10000) }
        return num;
    },
    iswx: function () {																					//判断是否是否微信
        return navigator.userAgent.toLowerCase().match(/MicroMessenger/i) == "micromessenger";
    },
    iswx6_1: function () {
        return navigator.userAgent.toLowerCase().match(/MicroMessenger\/6.1/i) == "micromessenger/6.1";
    },
    iswx6_2: function () {
        return navigator.userAgent.toLowerCase().match(/MicroMessenger\/6.2/i) == "micromessenger/6.2";
    },
    iosversion: function () {

        var u = navigator.userAgent;
        return u.match(/OS [0-6]_\d[_\d]* like Mac OS X/i);
    },
    language: (navigator.browserLanguage || navigator.language).toLowerCase(),
    anim: {
        run: function (from, to, callback, endcall, speed) {
            this.start(from, to, speed, null, callback, endcall);
        },
        start: function (from, to, speed, span, callback, endcall) {
            var cfg = { from: from, to: to, span: span, speed: speed, callback: callback, endcall: endcall }
            cfg.sign = cfg.from > cfg.to ? -1 : 1;		//定义符号。是递增还是递进
            cfg.span = cfg.span ? cfg.span : 5;       //设置默认递进量
            cfg.speed = cfg.speed ? cfg.speed : 50;	//设定默认速度
            cfg.current = 0;
            this.loop(cfg);
        },
        loop: function (cfg) {
            var me = this;
            cfg.current += cfg.span * cfg.sign;
            if (cfg.sign > 0 ? cfg.current > cfg.to : cfg.current < cfg.to) { if (cfg.endcall) { cfg.endcall() }; return }
            if (cfg.callback) { cfg.callback(cfg.current) }
            window.setTimeout(function () { me.loop(cfg) }, cfg.speed);
        }
    },
    loop: {
        looptimeout: null,
        jobs: {},
		count:0,
        loop: function () {												//私有方法
            var me = this;
            this.looptimeout = window.setTimeout(function name() { st.loop.loop() }, 1);
            for (var o in this.jobs) {
				if (me.jobs[o] && me.count%me.jobs[o].sleep==0){
					me.jobs[o].func()
				}
			}
			me.count++;
        },
        addloop: function (key,func,sleep) {						//添加指定方法到循环序列
            this.jobs[key] ={func:func,sleep:sleep?sleep:100};
            if (!this.looptimeout) { st.loop.loop() }
        },
        removeloop: function (key) {										//取消循环
            this.jobs[key] = null;
        }
    },
    select:{
        showmemoryselect:function (key,obj,json) {  //key 为存储本地的标识 obj:select对象,json为select的所有数据 注意json应符合getpyoption的格式
            var dj = st.getstore(key);
            if(st.isempty(dj.temp)){
                obj.html("<option value='-1'>==请选择==</option>" + st.getpyoption("", json));
            }else {
                var str = "";
                var num = -1;
                for (var y in dj.temp) {
                    var t1 = dj.temp[y];
                    for (var i in json) {
                        var t2 = json[i];
                        if (t1.id == t2.id) {
                            str += "<option value=" + t2.id + ">" + t2.name + "</option>";
                            num = i;
                        }
                    }
                    if (num != -1) {
                        var tempjson = st.arrayremove(json, num);
                        json = tempjson;
                    }
                }
                obj.html("<option value='-1'>==请选择==</option>" + str + st.getpyoption("", json));
            }
        },
        memoryselect:function (key,number,obj) {   //记忆下拉列表历史点击个数   key 为存储本地的标识, number记录的个数, obj单个option的对象,获取id信息
            var temp = $.parseJSON("{\"temp\":[]}");
            var json = st.getstore(key,temp);
            if(json.temp.length < number ){
                var p = {
                    "id":obj.val(),
                    "time":st.now()
                };
                var num = 0;
                for(var i in json.temp){
                    var t = json.temp[i];
                    if(obj.val() == t.id){
                        num++;
                        t.time=st.now();
                    }
                }
                if(num ==0){
                    json.temp[json.temp.length]=p;
                }
                json.temp.sort(function(b,a){
                    return Date.parse(a.time) - Date.parse(b.time);//时间倒叙
                });
                st.setstore(key,json);
            }else{
                var p2 = {
                    "id":obj.val(),
                    "time":st.now()
                };
                var num = 0;
                for(var i in json.temp){
                    var t = json.temp[i];
                    if(obj.val() == t.id){
                        num++;
                        t.time=st.now();
                    }
                }
                if(num == 0){
                    json.temp[number-1] = p2;
                }
                json.temp.sort(function(b,a){
                    return Date.parse(a.time) - Date.parse(b.time);//时间倒叙
                });
                st.setstore(key,json);
            }

        },
    },
	version:function(code){						//将版本号转换成文字形式版本
		if(!code){return '-'}
		var scode=String(code)
		return Math.floor(code/100)+'.'+scode[scode.length-2]+'.'+scode[scode.length-1]
	},
    click: function (obj, callback) {
        obj.unbind().bind((st.versions.ios || st.versions.android) ? 'touchstart' : 'click', callback);
    },
    c: function (obj, callback) {
        obj.unbind().bind((st.versions.ios || st.versions.android) ? 'touchstart' : 'click', function () { if (audio) { audio.playbutton() }; callback() });
    },
    inputmaxlen: function (obj) {
        var len = this.int(obj.attr('maxlength'));
        if (obj.size() < 1) { return; }
        obj.get(0).oninput = function () { if (this.value.length > len) { this.value = this.value.slice(0, len); return; } }
    },
    pattr: function (obj, name) {												//向上查找第一个匹配的属性。并返回
        var rval;
        obj.parents().each( function () {
            if (rval) { return;}
            if (typeof ($(this).attr(name)) != "undefined") {   rval = $(this).attr(name) }
        });
        return rval;
    },
    strlen: function (str) {									/*获取字符串真实长度。汉字被算为两个字节*/
        return str.replace(/[^x00-xff]/g, "xx").length;
    },
    scrollbottom: function (obj) {
        if (!obj || obj.size() < 1) { return }
        obj.scrollTop(obj[0].scrollHeight);
    },
    htmlclear: function (str) {								/*清除掉html标记*/
        return str.replace(/<[^>].*?>/g, "");
    },
    fontclear: function (str) {								/*清除默认的font标记*/
        return str.replace(/<\/?font.*?>/g, "");
    },
    hashtml: function (str) {
        return /<[^>].*?>/g.test(str);
    },
    clearnbsp: function (str) {
        if (!str) { return str }
        return str.replace(/&nbsp;/g, ' ');
    },
    startwith: function (source, str) {                         //判断字符串是否以指定字符串开始
        if (!source || !str) { return false }
        return source.indexOf(str) == 0;
    },
    clearexthtml: function (str) {								//清除编辑框多余的html(font不清除)
        var temp = $('<p></p>'); temp.html(str);
        temp.children().each(function () {
            if (!$(this).is('font')) {
                $(this).replaceWith('<font>' + $(this).text() + '</font>');
            }
        });
        return temp.html();
    },
    cansee: function (obj) {										//是否可见
        if (!obj) { return false }
        return !(obj.css('display') == 'none' || obj.css('visibility') == 'hidden');
    },

    setcookie: function (cname, cvalue, exdays) {  //设置cookie
        var d = new Date();
        d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
        var expires = "expires=" + d.toUTCString();
        document.cookie = cname + "=" + cvalue + "; " + expires + ";path=/;";
    },

    getcookie: function (cname) { //获取cookie
        var name = cname + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1);
            if (c.indexOf(name) != -1) return c.substring(name.length, c.length);
        }
        return "";
    },
    clearcookie: function (name) {   //清除cookie  
        st.setcookie(name, "", -1);
    },
    parsearray: function (keys, txt, scode) {                                      //将逗号分隔+回车形式的字符串转换成json数组。keys：逗号分隔的键。如:key1,key2,key3。txt：回车分行，自定字符分字段的字符串。默认,号分隔
        if (!keys || !txt) { return }
        var split = scode ? scode : ',';
        var list = txt.split('\n');
        var keyarr = keys.split(',');
        var rlist = [];
        for (var o in list) {
            if (list[o].indexOf('*') == 0) { continue; }
            var cols = list[o].split(split);
            if (cols.length < keyarr.length) { continue }
            var obj = {}
            for (var j = 0; j < keyarr.length; j++) {
                obj[keyarr[j]] = cols[j];
            }
            rlist[rlist.length] = obj;
        }
        return rlist;
    },
    parseobj: function (keys, txt, scode) {                                        //将逗号分隔*开始的字符串转换成json对象。只转第一行。
        if (!keys || !txt) { return {} }
        var split = scode ? scode : ',';
        var list = txt.split('\n');
        if (list.length == 0 || list[0].indexOf('*') != 0) { return {} }
        var keyarr = keys.split(',');
        var cols = list[0].substr(1).split(split);
        if (cols.length < keyarr.length) { return {} }
        var obj = {}
        for (var j = 0; j < keyarr.length; j++) {
            obj[keyarr[j]] = cols[j];
        }
        return obj
    },
    copy: function (sObj) {                                                      //深度拷贝一个数据对象
        if (typeof sObj !== "object") {
            return sObj;
        }
        var s = {};
        if (sObj.constructor == Array) {
            s = [];
        }
        for (var i in sObj) {
            s[i] = this.copy(sObj[i]);
        }
        return s;
    },
	clipboard:function(obj,getcallback){//为对象注册点击剪切板。getcallback:获取数据的回调
		var handler=function(event) {
			event.clipboardData.setData('text/plain', getcallback?getcallback():'');
			event.preventDefault();
		}
		obj.addEventListener('copy', handler);		// 增加copy监听
		document.execCommand('copy');					// 执行copy命令触发监听
		obj.removeEventListener('copy', handler);   // 移除copy监听，不产生影响
	},
    count: function (arr, key, equal) {                                              //统计集合中指定键的值等于指定值的数量。
        if (!arr || arr.constructor != Array) { return 0 }
        var c = 0;
        for (var o in arr) { if (arr[o][key] == equal) { c++ } }
        return c;
    },
    getcookie: function (name)                                                    //读取cookie
    {
        var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
        if (arr = document.cookie.match(reg))
            return unescape(arr[2]);
        else
            return null;
    },
    moneydef: function (num) {                                                    //返回钱的默认值
        return num ? num : '0.00';
    },
    setcookie: function (key, value) {
        var Days = 30;
        var exp = new Date();
        exp.setTime(exp.getTime() + Days * 24 * 60 * 60 * 1000);
        document.cookie = key + "=" + escape(value) + ";expires=" + exp.toGMTString();
    },
    getcookie: function (key) {
        var arr, reg = new RegExp("(^| )" + key + "=([^;]*)(;|$)");
        if (arr = document.cookie.match(reg))
            return unescape(arr[2]);
        else
            return null;
    },
    delcookie: function (key) {
        var exp = new Date();
        exp.setTime(exp.getTime() - 1);
        var cval = this.getcookie(key);
        if (cval != null)
            document.cookie = key + "=" + cval + ";expires=" + exp.toGMTString();
    },
    saveas: function (src) {
        var oPop = window.open(src, "", "width=1, height=1, top=5000, left=5000");
        for (; oPop.document.readyState != "complete";)
        { if (oPop.document.readyState == "complete") break; }
        oPop.document.execCommand("SaveAs"); oPop.close();
    },
    formatfloat2: function (strnum) {                                      //将字符型的小数保留两位
        try {
            return (strnum * 1).toFixed(2)
        } catch (e) {
            return 0;
        }
    },
    round2:function (number){       //四舍五入保留2位小数 
        fractionDigits=2;
        with(Math){  
            return round(number*pow(10,fractionDigits))/pow(10,fractionDigits);  
        }
    },
    str: function (s) {
        return s ? s : '';
    },
    q: function (s) {				//获取url中的请求参数
        return $.queryString(s);
    },
	qi:function(s){					//获取url中的请求参数(int型)
		return st.int(this.q(s));
	},
    firstmatch: function (str, reg) {                                        //获取第一个匹配项
        var m = reg.exec(str);
        if (m && m.length > 1) { return m[1] }
        return '';
    },
    urlset: function (url, para, sharp) {      //设置用json覆盖掉url对应的参数。并返回新的url。para格式为：{p1:1,p2:2},sharp:12233
        var json = this.urltojson(url);
        for (var o in para) { json.para[o] = para[o] }
        if (sharp) { json.sharp = sharp }
        return this.jsontourl(json);
    },
    urltojson: function (url)         //将url转换成json格式。格式{page:'http://www.baidu.com',para:{p1:1,p2:2},sharp:12233}.para为参数集合.sharp为
    {
        var j = { para: {} }, temp = {}
        j.page = url.split('?')[0];
        temp.para = url.substr(j.page.length);
        temp.para = temp.para.length = 0 ? temp.para : temp.para.substr(1);
        j.sharp = this.firstmatch(temp.para, /#([^\&]+)/g);
        temp.para = temp.para.replace('#' + j.sharp, '');
        if (!st.isempty(temp.para)) { temp.paras = temp.para.split('&') };
        for (var o in temp.paras) {
            var p = temp.paras[o].split('=');
            j.para[p[0]] = p.length > 1 ? p[1] : '';
        }
        return j;
    },
    d: function (num1, num2) {            										//安全的除法
        if (num2 == 0) { return (num2 * 1).toFixed(2) }
        return (num1 / num2).toFixed(2);
    },
	di:function(num1,num2,isfloor=true){			//安全除,并把结果转换成int。默认不四舍五入
		var num=this.d(num1,num2);
		return isfloor?Math.floor(num):Math.round(num)
	},
    jsontourl: function (json) {       //将标准格式的url转换成para
        var p = '';
        for (var o in json.para) { if (json.para[o] != null) { p += '&' + o + '=' + json.para[o] } }
        return json.page + (p.length == 0 ? '' : '?' + p.substr(1)) + (json.sharp ? '#' + json.sharp : '');
    },
    round: function (num) {
        return Math.round(num);
	},
	getrangenum:function(num,max,min=0){			//获取指定区间的数值。过界取上下限。下限默认0
		return num>max?max:(num<min?min:num);
    }
}
/**html元素构造类**/
var html={
	getoption:function(val,text){						//返回select的option元素
		return $('<option></option>').val(val).text(text);
	},
	getli:function(val,text){							//返回ul中的li元素
		return $('<li></li>').val(val).text(text);
	},
    getpageul:function(index,pages,callback){			//返回设置好的翻页控件
        var ul=$('<ul class="pagination"></ul>');
		if(pages==0){return ul}
		var start=index%10==0?index-10:index-index%10;
		var prev=$('<li><a>&laquo;</a></li>').attr('p',start-1);
		if(start==0){st.class(prev,'disabled')}
		ul.append(prev);
		for(var i=0;i<10;i++){
			if(i+start>=pages){break;}
			li=$('<li><a></a></li>')
			li.find('a').text(i+start+1);
			li.attr('p',i+start+1);
			if(i+start==index-1){st.class(li,'active')}
			ul.append(li);
		}
		var next=$('<li><a>&raquo;</a></li>').attr('p',start+11);
		if(start+10>=pages){st.class(next,'disabled')}
		ul.append(next);
		ul.find('li').click(function(){
			if(this.className=='disabled'){return}
			if(callback){callback($(this).attr('p'))}
		});
		return ul;
    },
	geta:function(title,callback,href){
		var a=$('<a></a>')
		if(title){a.text(title)}
		if(callback){a.click(function(){callback($(this))});}
		if(href){a.attr('href',href)}
		return a;
	},
	/**
	 * 将json格式的字符串或json转换格式化的html串。
	 * */
	json:function(json){
		var j=typeof(json)=='string'?st.tojson(json):json;
		j=st.jksort(j)
		return JSON.stringify(j,null,'\t')
			.replace(/\t/g,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;')
			.replace(/\r/g,'\n')
			.replace(/\n/g,'<br/>')
	}
}
var loading = {
    div: null,
    show: function (notshow) {
        if (this.div == null) {
            this.div = $('<div style="position: fixed;z-index:10000; width: 100%; height: 100%; left: 0px;text-align:center;top: 0px;"><div style="font-size: 20px; margin-top: 360px; color:white; width: 200px; background-color: rgba(0,0,0,0.6); border-radius: 10px; padding: 30px 0px;margin-left: auto; margin-right: auto;text-align: left; padding-left: 55px;"></div></div>');
			if(notshow){this.div.find('div').hide()}
            $('body').append(this.div);
        }
        this.div.show(); this.run = true; this.points = []; this.change();
    },
    run: true,
    points: [],
    change: function () {
        var me = this;
        if (!me.run) { return; }
        if (me.points.length > 6) { me.points = [] }
        me.points[me.points.length] = '.';
        this.div.find('div').text('loading' + me.points.join(''));
        window.setTimeout(function () { me.change(); }, 300);
    },
    hide: function () {
        this.run = false;
        this.div.hide();
    }
}
